/* This file is part of the code used to analyze data for 
Pitchers et al. 2018 (or 2019), A multivariate genome-wide association 
study of wing shape in Drosophila melanogaster to be published in Genetics. */

* This cluster analysis is representative of the methods used in the paper, but not the definite clustering.  
* We adjusted clusters in subsequent runs as described in the Supplementary Materials and Methods.; 

* Re-cluster of significant set prior to testing SNP-SNP interactions and building interaction networks;
* In this iteration, we impute missing data after the first iteration, which allows for a much finer ;
* cluster assignment (albeit it is more time consuming);

libname alldata "D:\Dropbox\DH\Flywing\DGRP\GWAS programs and data\data";

data snps;
 set alldata.fdr5sigsnps;
 *keep snp L:;
run;

data snpcn;
 set snps;
 allmean = mean(of L:);
 allnorm = sqrt(css(of L:));
run;
data snpcn;
 set snpcn;
L21=(L21-allmean)/allnorm;L26=(L26-allmean)/allnorm;L28=(L28-allmean)/allnorm;L38=(L38-allmean)/allnorm;L40=(L40-allmean)/allnorm;L41=(L41-allmean)/allnorm;L42=(L42-allmean)/allnorm;
L45=(L45-allmean)/allnorm;L57=(L57-allmean)/allnorm;L59=(L59-allmean)/allnorm;L69=(L69-allmean)/allnorm;L73=(L73-allmean)/allnorm;L75=(L75-allmean)/allnorm;L83=(L83-allmean)/allnorm;
L85=(L85-allmean)/allnorm;L88=(L88-allmean)/allnorm;L91=(L91-allmean)/allnorm;L93=(L93-allmean)/allnorm;L101=(L101-allmean)/allnorm;L105=(L105-allmean)/allnorm;
L109=(L109-allmean)/allnorm;L129=(L129-allmean)/allnorm;L136=(L136-allmean)/allnorm;L138=(L138-allmean)/allnorm;L142=(L142-allmean)/allnorm;L149=(L149-allmean)/allnorm;
L153=(L153-allmean)/allnorm;L158=(L158-allmean)/allnorm;L161=(L161-allmean)/allnorm;L176=(L176-allmean)/allnorm;L177=(L177-allmean)/allnorm;L181=(L181-allmean)/allnorm;
L189=(L189-allmean)/allnorm;L195=(L195-allmean)/allnorm;L208=(L208-allmean)/allnorm;L217=(L217-allmean)/allnorm;L223=(L223-allmean)/allnorm;L227=(L227-allmean)/allnorm;
L228=(L228-allmean)/allnorm;L229=(L229-allmean)/allnorm;L233=(L233-allmean)/allnorm;L235=(L235-allmean)/allnorm;L237=(L237-allmean)/allnorm;L239=(L239-allmean)/allnorm;
L256=(L256-allmean)/allnorm;L280=(L280-allmean)/allnorm;L287=(L287-allmean)/allnorm;L301=(L301-allmean)/allnorm;L303=(L303-allmean)/allnorm;L304=(L304-allmean)/allnorm;
L306=(L306-allmean)/allnorm;L307=(L307-allmean)/allnorm;L309=(L309-allmean)/allnorm;L310=(L310-allmean)/allnorm;L313=(L313-allmean)/allnorm;L315=(L315-allmean)/allnorm;
L317=(L317-allmean)/allnorm;L318=(L318-allmean)/allnorm;L319=(L319-allmean)/allnorm;L320=(L320-allmean)/allnorm;L321=(L321-allmean)/allnorm;L324=(L324-allmean)/allnorm;
L325=(L325-allmean)/allnorm;L332=(L332-allmean)/allnorm;L335=(L335-allmean)/allnorm;L336=(L336-allmean)/allnorm;L338=(L338-allmean)/allnorm;L340=(L340-allmean)/allnorm;
L350=(L350-allmean)/allnorm;L352=(L352-allmean)/allnorm;L356=(L356-allmean)/allnorm;L357=(L357-allmean)/allnorm;L358=(L358-allmean)/allnorm;L359=(L359-allmean)/allnorm;
L360=(L360-allmean)/allnorm;L361=(L361-allmean)/allnorm;L362=(L362-allmean)/allnorm;L365=(L365-allmean)/allnorm;L367=(L367-allmean)/allnorm;L370=(L370-allmean)/allnorm;
L371=(L371-allmean)/allnorm;L373=(L373-allmean)/allnorm;L374=(L374-allmean)/allnorm;L375=(L375-allmean)/allnorm;L377=(L377-allmean)/allnorm;L379=(L379-allmean)/allnorm;
L380=(L380-allmean)/allnorm;L381=(L381-allmean)/allnorm;L382=(L382-allmean)/allnorm;L383=(L383-allmean)/allnorm;L385=(L385-allmean)/allnorm;L386=(L386-allmean)/allnorm;
L391=(L391-allmean)/allnorm;L392=(L392-allmean)/allnorm;L399=(L399-allmean)/allnorm;L405=(L405-allmean)/allnorm;L406=(L406-allmean)/allnorm;L409=(L409-allmean)/allnorm;
L426=(L426-allmean)/allnorm;L427=(L427-allmean)/allnorm;L437=(L437-allmean)/allnorm;L439=(L439-allmean)/allnorm;L440=(L440-allmean)/allnorm;L441=(L441-allmean)/allnorm;
L443=(L443-allmean)/allnorm;L461=(L461-allmean)/allnorm;L486=(L486-allmean)/allnorm;L491=(L491-allmean)/allnorm;L492=(L492-allmean)/allnorm;L502=(L502-allmean)/allnorm;
L508=(L508-allmean)/allnorm;L509=(L509-allmean)/allnorm;L513=(L513-allmean)/allnorm;L517=(L517-allmean)/allnorm;L530=(L530-allmean)/allnorm;L531=(L531-allmean)/allnorm;
L535=(L535-allmean)/allnorm;L555=(L555-allmean)/allnorm;L563=(L563-allmean)/allnorm;L584=(L584-allmean)/allnorm;L589=(L589-allmean)/allnorm;L595=(L595-allmean)/allnorm;
L639=(L639-allmean)/allnorm;L642=(L642-allmean)/allnorm;L646=(L646-allmean)/allnorm;L703=(L703-allmean)/allnorm;L705=(L705-allmean)/allnorm;L707=(L707-allmean)/allnorm;
L712=(L712-allmean)/allnorm;L714=(L714-allmean)/allnorm;L716=(L716-allmean)/allnorm;L721=(L721-allmean)/allnorm;L730=(L730-allmean)/allnorm;L732=(L732-allmean)/allnorm;
L737=(L737-allmean)/allnorm;L738=(L738-allmean)/allnorm;L748=(L748-allmean)/allnorm;L757=(L757-allmean)/allnorm;L761=(L761-allmean)/allnorm;L765=(L765-allmean)/allnorm;
L774=(L774-allmean)/allnorm;L776=(L776-allmean)/allnorm;L783=(L783-allmean)/allnorm;L786=(L786-allmean)/allnorm;L787=(L787-allmean)/allnorm;L790=(L790-allmean)/allnorm;
L796=(L796-allmean)/allnorm;L799=(L799-allmean)/allnorm;L801=(L801-allmean)/allnorm;L802=(L802-allmean)/allnorm;L804=(L804-allmean)/allnorm;L805=(L805-allmean)/allnorm;
L808=(L808-allmean)/allnorm;L810=(L810-allmean)/allnorm;L812=(L812-allmean)/allnorm;L818=(L818-allmean)/allnorm;L819=(L819-allmean)/allnorm;L820=(L820-allmean)/allnorm;
L821=(L821-allmean)/allnorm;L822=(L822-allmean)/allnorm;L832=(L832-allmean)/allnorm;L837=(L837-allmean)/allnorm;L843=(L843-allmean)/allnorm;L849=(L849-allmean)/allnorm;
L850=(L850-allmean)/allnorm;L852=(L852-allmean)/allnorm;L853=(L853-allmean)/allnorm;L855=(L855-allmean)/allnorm;L857=(L857-allmean)/allnorm;L859=(L859-allmean)/allnorm;
L861=(L861-allmean)/allnorm;L879=(L879-allmean)/allnorm;L882=(L882-allmean)/allnorm;L884=(L884-allmean)/allnorm;L887=(L887-allmean)/allnorm;L890=(L890-allmean)/allnorm;
L892=(L892-allmean)/allnorm;L894=(L894-allmean)/allnorm;L897=(L897-allmean)/allnorm;L900=(L900-allmean)/allnorm;L907=(L907-allmean)/allnorm;L908=(L908-allmean)/allnorm;
L911=(L911-allmean)/allnorm;L913=(L913-allmean)/allnorm;
run;

data alldata.snpsfreeze2_f2FDR5pct_normalized;
 merge snpcn(keep=snp L: allmean allnorm) snpcn(drop=snp L: allmean allnorm);
run;

* First pass of FASTCLUS, to IMPUTE missing values;
proc fastclus maxclusters=4000 strict radius=0.7654 impute noprint
 data=snpcn
 out=snpclusters;
 VAR L:;
run;
data snpscn;
 set snpclusters;
run;
* First pass of FASTCLUS, using imputed values;
proc fastclus maxclusters=4000 strict radius=0.7654 noprint
 data=snpscn
 outseed=snpclusterstats
 out=snpclusters;
 VAR L:;
run;
data alldata.snpclusters_norm0full;
 merge snpcn(keep=snp) snpclusters;
run;
proc sort data=alldata.snpclusters_norm0full;
 by snp;
run;
data snpclusterseed; *To use in further passes (below);
 set snpclusterstats;
 rename _CRIT_=_SEEDCRIT_ CLUSTER=SEEDCLUSTER _FREQ_=_SEEDFREQ_ _RMSSTD_=_SEEDRMSSTD_ _RADIUS_=_SEEDRADIUS_ _NEAR_=_SEEDNEAR_ _GAP_=_SEEDGAP_;
run;
proc sort data=snpclusterstats out=alldata.snpclusterstats_norm0full;
 by descending _freq_;
run;

**** Additional passes of FASTCLUS (output NOT saved, loop any number of times);
proc fastclus maxclusters=4000 radius=0.7654 strict noprint
 data=snpscn
 seed=snpclusterseed
 outseed=snpclusterstats
 out=snpclusters;
 VAR L:;
run;
data loopcomp;
 merge snpclusterseed(keep=_SEEDCRIT_) snpclusterstats(keep=_CRIT_)
 	   snpclusterseed(keep=SEEDCLUSTER) snpclusterstats(keep=CLUSTER)
	   snpclusterseed(keep=_SEEDFREQ_) snpclusterstats(keep=_FREQ_)
	   snpclusterseed(keep=_SEEDRMSSTD_) snpclusterstats(keep=_RMSSTD_)
	   snpclusterseed(keep=_SEEDRADIUS_) snpclusterstats(keep=_RADIUS_)
	   snpclusterseed(keep=_SEEDNEAR_) snpclusterstats(keep=_NEAR_)
	   snpclusterseed(keep=_SEEDGAP_) snpclusterstats(keep=_GAP_)
     ;
run;
data snpclusterseed; *To use in further passes (below);
 set snpclusterstats;
 rename _CRIT_=_SEEDCRIT_ CLUSTER=SEEDCLUSTER _FREQ_=_SEEDFREQ_ _RMSSTD_=_SEEDRMSSTD_ _RADIUS_=_SEEDRADIUS_ _NEAR_=_SEEDNEAR_ _GAP_=_SEEDGAP_;
run;
****END of LOOP;

* Export results from most recent iteration (edit name to match);
data alldata.snpclusters_norm9full;
 set snpclusters;
run;
proc sort data=alldata.snpclusters_norm9full;
 by snp;
run;
proc sort data=snpclusterstats out=alldata.snpclusterstats_norm9full;
 by descending _freq_;
run;
PROC EXPORT
 DATA=alldata.snpclusters_norm9full
 DBMS=CSV REPLACE
 OUTFILE= "D:\Dropbox\DH\Flywing\DGRP\GWAS programs and data\ClusterAnalysis\snpclusters_norm9full.csv";
RUN;
PROC EXPORT
 DATA=alldata.snpclusterstats_norm9full
 DBMS=CSV REPLACE
 OUTFILE= "D:\Dropbox\DH\Flywing\DGRP\GWAS programs and data\ClusterAnalysis\snpclusterstats_norm9full.csv";
RUN;


* Cluster statistics;
data clusters;
 set snpclusters(keep=snp cluster);
 *if cluster<0 then cluster=0;
run;
proc sort data=clusters;
 by cluster snp;
run;
proc means data=clusters;
 var snp;
 by Cluster;
 output out=clustercts;
run;
proc transpose data=clustercts out=tclustercts;
 by cluster;
 id _stat_;
run;

data alldata.SigClusters_f2FDR5pct;
 set tclustercts(where=(_NAME_="snp"));
 drop _name_ mean std;
 range = max-min;
run;
PROC EXPORT
 DATA=alldata.SigClusters_f2FDR5pct
 DBMS=CSV REPLACE
 OUTFILE= "D:\Dropbox\DH\Flywing\DGRP\GWAS programs and data\ClusterAnalysis\SigClusters_f2FDR5pct.csv";
RUN;

** After exporting these clusters, "negative" clusters have to be individually vetted to ensure they are not hiding additional clusters (see culstrvet.m)
