/* GLMnet DGRP vs. dictionary vectors 2018.  For sharing with Genetics paper. 
data is in 
	alldata.glmnetwithman
	alldata.interlabsizejun - this file is generated by the supplied program MANOVAHIGHQchunk.sas
    eigenvectors for the two alignment spaces.  For the DGRP data: data/interlabeigjun.sas7bdat
		  For the dictionary data: data/interlabeigdec.sas7bdat
    data/pooledregestimates_preculled.sas7bdat - precalculated vectors for knock-down effects in the Dictionary.
Dictionary vectors are averaged over experiments by gene.

Full vectors are the regresson of shape on 10 x (log3 (mif)) levels omitting the 0 mif data. 
DGRP eigenvectors are the basis for all analyses of the DGRP data.  */

libname alldata "D:\Dropbox\DH\Flywing\DGRP\GWASsoftware\data";
*Tempperm is a temporary data set with fast access time and no backup.  Results get copied to the permanent repository alldata upon completion.  ;
libname tempperm "D:\Flywing\DGRP\data.freeze2\HQrev"; *This can be ommitted, but program needs to be modified for this.;
* libname Eladio "D:\Dropbox\Interlab\Highquality" The very large file of all MANOVA results that this points to has been omitted.  Recalculate MANOVA results to regenerate.;

* Vectors for the GLMnet significant SNPs.;
* First, cast these vectors into the December space;
data glmnetok;
 set  alldata.glmnetwithman;
 where glmnetOK=1;
run;
%macro convjun2dec(glmdat);
proc iml;
	  use alldata.interlableigjun;
	   read all var _ALL_ where(_TYPE_='SCORE') into juneigvec;
		read all var _ALL_ where(_TYPE_='MEAN') into junmeanvec;
	  close alldata.interlableigjun;
	  use alldata.interlableigdec;
	   read all var _ALL_ where(_TYPE_='SCORE') into deceigvec;
		read all var _ALL_ where(_TYPE_='MEAN') into decmeanvec;
	  close alldata.interlableigdec;
		use &glmdat;
		  read all var{
		  %do i=1 %to 58;
		     GLMPrin&i
		  %end;
		 } into SNPvecs;
		close &glmdat;
	* Now put the SNP vectors in the same space as the December vectors;

		 snpxy=snpvecs*juneigvec[1:58,];	
		 		
		 print (nrow(snpvecs)) (ncol(snpvecs)) (nrow(juneigvec)) (ncol(juneigvec));	
		 print (nrow(snpxy)) (ncol(snpxy));
		 snpdec = snpxy*deceigvec[1:58,]`;
		 print (nrow(snpvecs)) (ncol(snpvecs)) (nrow(juneigvec)) (ncol(juneigvec));	
		 		
		 print (nrow(snpdec)) (ncol(snpdec));
		 jdcorr=j(nrow(snpvecs),1,0);
		 do i = 1 to nrow(snpvecs);
		    lengthjun=sqrt(snpvecs[i,]*snpvecs[i,]`);
			lengthdec=sqrt(snpdec[i,]*snpdec[i,]`);
			jdcorr[i]=snpvecs[i,]*snpdec[i,]`/(lengthjun*lengthdec);
			print 'lengths and corr' lengthjun lengthdec (jdcorr[i]);
		 end;
		 snpdec=snpdec||jdcorr;
 create snpdec from snpdec[colname={
		  %do i=1 %to 58;
		     GLMPrindec&i
		  %end;
jdcorr}];
   append from snpdec;
  quit;
data snpindec;
 merge &glmdat snpdec;
 rename 
%do i=1 %to 58;
   GLMPrin&i= GLMPrinjun&i
%end;
 ;
run;

%mend;
%convjun2dec(glmnetok);

* Freeze2 HQ SNP vectors are in variables Prindec1-Prindec58;

data geness;
length snp cluster 8.;
set snpindec;
 genec = gene1;
 rename cluster=LDcluster;
run;
proc sort data=geness;
 by genec;
run;
proc freq data=geness;
 tables genec / out=genelist;
 run;
proc sort data=geness;
 by ldcluster;
run;
proc freq data=geness;
tables genec / out=genesclust;
  by ldcluster;
run;
proc freq data=genesclust;
 tables ldcluster / out=genesperclust;
 run;
data genesperclust;
 set genesperclust;
 label count='siggenesclust';
 rename count=siggenesclust;
run;
data genesnpvect;
 length snp 8 gene1 $8;
 set geness;
 genec = lowcase(gene1);
 freqweight=maf*(1-maf);
 * For this analysis there are two possible sources to match up with SNPS: Dictionary and Mutants.; 
 s2='Dictionary';
 output;
 s2='Mutant';
 output;
 /* Old matching. select;
 when (genec='d') do; * gene dachs is a special case, because there are two different experiments with the B source RNAi.;
   source='B1';
   output;
   source='B2';
   output;
  end;
 when (genec='ds') do;* gene dachsous is a special case, because there are two different experiments with the V source RNAi.;
   source='V1';
   output;
   source='V2';
   output;
  end;
  otherwise do;
   source='B';
    output;
  end;
  end;
 source='D';
 output;
 source='V';
 output; */
 run;
proc sort data=genesnpvect;
 by genec;
run;
data genesnpvect2;
 length snp 8 gene2 $8;
 set geness;
 where gene2^='' & abs(dist1)<5000;
 genec = lowcase(gene2);
 freqweight=maf*(1-maf);
 * For this analysis there are two possible sources to match up with SNPS: Dictionary and Mutants.; 
 s2='Dictionary';
 output;
 s2='Mutant';
 output;
 run;
proc sort data=genesnpvect2;
 by genec;
run;
* Get line covariance matrix, in the December data space.;
%macro prepdata;
data females;
 set alldat.interlabsizejun;
  where sex='F' and lab='Dwo';
  keep linenum  logcs
  %do i=1 %to 58;
     Prin&i
  %end;
  ;
run;
proc iml;
	  use alldata.interlableigjun;
	   read all var _ALL_ where(_TYPE_='SCORE') into juneigvec;
		read all var _ALL_ where(_TYPE_='MEAN') into junmeanvec;
	  close alldata.interlableigjun;
	   use alldata.interlableigdec;
	   read all var _ALL_ where(_TYPE_='SCORE') into deceigvec;
		read all var _ALL_ where(_TYPE_='MEAN') into decmeanvec;
	  close alldata.interlableigdec;
		use females;
		  read all var{
		  %do i=1 %to 58;
		     Prin&i
		  %end;
		 } into fshapes;
		close females;
	* Now put the SNP vectors in the same space as the vectors;

		 shapexy=fshapes*juneigvec[1:58,];	
		 shapedec = shapexy*deceigvec[1:58,]`;
 create shapedec from shapedec[colname={
		  %do i=1 %to 58;
		     Prindec&i
		  %end;
}];
   append from shapedec;
  quit;
data shapeindec;
 merge females shapedec;
 drop Prin1-Prin58;
run;
proc sort data=shapeindec;
 by linenum;
run;
proc means data=shapeindec;
 var Prindec1-Prindec58;
 run;
proc means data=shapeindec noprint;
 by linenum;
 var Prindec1-Prindec58;
 output out=llsmean mean=Prindec1-Prindec58;
 run;

* Get the covariance matrix for the line means, now in the December data space..;
proc princomp data=llsmean cov  outstat=lineigens noprint;
 var Prindec1-Prindec58; 
run;
%mend prepdata;
%prepdata;

*** Random sample of estimated vectors from MANOVA. ;  * This very large file (Eladio.hqmanova3) has not been included.  
Please first recompute random MANOVAs using the program MANOVAHighQchunko.sas; 
proc surveyselect data=Eladio.hqmanova3 out=randdirs n=100000;  
run;
data randdirs;
 set randdirs;
 where prin1^=.;
 run;

* Precull analysis is in alldat.avedicteffprecull ;
* mutvecs has the dictionary from the pre_culled set. ;
  data mutvecs;
  format insertoan $9.;
  set alldat.pooledregestimates_preculled;
   if insertoan='BSTAT92E' then delete;
  if insertoan="BD" then insertoan="Bd";
  run;
data dictgeneff;
 length genec $10. source $2. insertoan $9.;
 set mutvecs;
 if insertoan='' then insertoan=insert;
 genec = lowcase(substr(insertoan,2));
 if index(genec,'_')>0 then genec = substr(genec,1,index(genec,'_')-1);
 source=substr(insertoan,1,1);
 expt=compress(insertoan|| '-'|| date);
 run;
proc sort;
 by genec;
run;
proc means noprint data=dictgeneff(where=(source^='D'));
 by genec;
	 var madjPrin1-madjprin58;
	 output out=avedf mean=madjPrin1-madjprin58;
	run;
data alldat.avedicteffprecull;
 set avedf;
 s2='Dictionary';
run;
****** End constructing the Dictionary vector data set.;


* Get correlations of dictionary vectors;
%macro dictcorr(data);
data dict;
 set &data;
 where s2='Dictionary';
run;
proc iml;
  		use dict;
		  read all var{
			  %do i=1 %to 58;
			     madjPrin&i
			  %end;
			} into dictvecs;
		read all var{genec} into dictlab;
		close dict;
		print 'Dictionary vectors'  (nrow(dictvecs)) (nrow(dictlab));
		dictcorrs=j(nrow(dictvecs),nrow(dictvecs));
		dictlength=j(nrow(dictvecs),1);
		do i = 1 to nrow(dictvecs);
		  		dictlength[i,1]=sqrt(dictvecs[i,]*dictvecs[i,]`);
		end;
		print dictlength;
		do i = 1 to nrow(dictvecs);
				do j=1 to nrow(dictvecs);
			    dictcorrs[i,j]= abs(dictvecs[j,] *dictvecs[i,]`/(dictlength[i,1]*dictlength[j,1]));
				end;
		end;
		print dictcorrs;
		print (nrow(dictcorrs));
		dictcorl=dictlength || dictcorrs;
		print  (nrow(dictcorl)) (ncol(dictcorl));
		columnnames = "dictlength" || dictlab`;
		print  (nrow(columnnames)) (ncol(columnnames));
		create dictcor from dictcorl [colname= columnnames];
		append from dictcorr;
	quit;
   data dictcorr;
    merge dictcor dict (keep=genec);
run;
%mend;
%dictcorr(alldat.avedicteffpc);


**** Calculating gene matched vector correlations, provding matched estimates (glmveccorr) files for later use in other contexts.;
 * This does just the shape vectors, not the logcs.;
* Simpmatch just matches the vectors that share their nearest gene with a dictionary entry.;
 * PC is precull - that is the rawer data, not filtered for consistency, etc.;

%macro simpmatch(dictdata,bn,useclust,genesnp);
 * bn is the number of random correlations to calculate;

*** naming output file. ;
%if %index(&dictdata,precull)>1 %then %let cull=pre;
%else %let cull=post;
%let outfile=GLMnetsimpcorr&useclust.&cull;
****** delete old output files.;
%if %sysfunc(exist(tempperm.&outfile)) %then %do;
proc datasets lib=tempperm;
 delete &outfile;
  run;
 %end;
**** End deleting old output files. ;

options nomlogic nomprint nosymbolgen;
proc sort data=&dictdata;
 by genec s2;
run;
proc sort data=&genesnp;
 by genec s2 LDcluster;
run;

****** Calculating various averages of the SNP effects.;
%if &useclust=clust %then %do;
	* These are LD clusters from Eladio.;
	* Calculate means by cluster;
/* 	proc sort data=&genesnp;
	 by ldcluster;
	run; 
	data interp;
	 merge genesperclust(where=(siggenesclust=1) in=a) &genesnp;
	 by ldcluster;
	 if A;
	run;
	proc sort;
	 by genec s2 ldcluster;
	 run;
proc means noprint data=interp; */
	proc sort data=&genesnp;
	 by genec s2 ldcluster;
	 run;
    proc means noprint data=&genesnp;
	 var GLMPrindec1-GLMPrindec58 GLMPrinjun1-GLMPrinjun58 glmeffsz;
	 by genec s2 ldcluster;
	 weight freqweight;
	 id snp dist1 class1;
	 output out=geneclustvect mean=GLMPrindec1-GLMPrindec58 GLMPrinjun1-GLMPrinjun58 glmeffsz;
	run;
	proc sort;
	 by genec s2;
	 run;
	data matches;
	 merge &dictdata(in=a) geneclustvect (in=b);
	 by genec s2;
	 if a & b;
	 rename _FREQ_=numsnpcluster;
	 drop _TYPE_;
	run;
	* proc sort data=matches out=matches2 nodupkey;
	*  by genec s2;
	*  run;
%end;
%else %if  &useclust=ave %then %do;
 	* ave averages all the SNP effects within a gene.;
	* These are LD clusters from Eladio.;
	* Calculate means by cluster;
	/* proc sort data=&genesnp;
	 by ldcluster;
	run; 
	 data interp;
	 merge genesperclust(where=(siggenesclust=1) in=a) &genesnp;
	 by ldcluster;
	 if A;
	run; 
	proc sort;
	 by genec s2;
	 run;
	proc means noprint data=interp;*/
  proc sort data=&genesnp;
	 by genec s2;
	 run;
  proc means noprint data=&genesnp;
	 var GLMPrindec1-GLMprindec58 GLMPrinjun1-GLMPrinjun58 glmeffsz;
	 by genec s2;
	 weight freqweight;
	 id snp;
	 output out=geneclustvect mean=GLMPrindec1-GLMPrindec58 GLMPrinjun1-GLMPrinjun58 glmeffsz;
	run;

	proc sort;
	 by genec s2;
	 run;
	data matches;
	 merge &dictdata(in=a) geneclustvect (in=b);
	 by genec s2;
	 if a & b;
	 rename _FREQ_=numsnpcluster;
	 drop _TYPE_;
	run;
%end;
 %else %do; * all SNPs treated as data.;
	data matches;
	 merge &dictdata(in=a) &genesnp (in=b);
	 by genec s2;
	 if a & b;
	run;
%end;
* options mlogic mprint symbolgen;
**** Ending calculating averages of SNP effects by cluster or by gene.;

*** Doing the actual matching of the SNP effects and the dictionary effects.;
proc freq data= matches noprint;
 tables genec*s2 / out=nsnpspdict;
 run;
data dictsnpcount;
 length genec $8. count 8.;
 merge matches nsnpspdict (in=a);
 by genec s2;
 if genec='d' then delete;  * The dictionary is dachs, but no hits in dachs, just Dichaete.;
 rename count=snpcount;
 run;

 ******* This iml program calculates the actual correlations of effects, and then the correlations with random vectors.;
proc iml;
	  use alldata.interlableigjun;
	   read all var _ALL_ where(_TYPE_='SCORE') into juneigvec;
		read all var _ALL_ where(_TYPE_='MEAN') into junmeanvec;
	  close alldata.interlableigjun;
	  use alldata.interlableigdec;
	   read all var _ALL_ where(_TYPE_='SCORE') into deceigvec;
		read all var _ALL_ where(_TYPE_='MEAN') into decmeanvec;
	  close alldata.interlableigdec;
		use dictsnpcount;
		  read all var{
			  %do i=1 %to 58;
			     madjPrin&i
			  %end;
			} into dictvecs;
		  read all var{
		  %do i=1 %to 58;
		     GLMPrindec&i
		  %end;
		 } into SNPvecs;
			read all var{
		  %do i=1 %to 58;
		     GLMPrinjun&i
		  %end;
		 } into SNPjunvecs;
		read all var{genec s2} into alllab;
		close dictsnpcount;
		* Read in covariance and PC vectors for the DGRP among-line covariance matrix.;
	    use lineigens;
			 read all var{ %do i=1 %to 58;
			     Prindec&i
			  %end; 
			}   where (_TYPE_='COV') into linecov; 
			read all var{ %do i=1 %to 58;
			     Prindec&i
			  %end; 
			}   where (_TYPE_='SCORE') into DGRPPC; 
			 close lineigens;

		corrlen=j(nrow(snpvecs),14);
		print 'Correlations of dictionary, PCS and snps.';
		do i = 1 to nrow(snpvecs);
			if nmiss(snpvecs[i,])>0 | nmiss(dictvecs[i,])>0 then do;
			    print 'Missing values in i loop';
				print(snpvecs[ncorr,]) (dictvecs[i,]);
			  end;

		  		corrlen[i,1]=sqrt(dictvecs[i,]*dictvecs[i,]`);
				corrlen[i,2]=sqrt(snpvecs[i,]*snpvecs[i,]`);
			    corrlen[i,3]= abs(snpvecs[i,] *dictvecs[i,]`/(corrlen[i,1]*corrlen[i,2]));
			    corrlen[i,4]= abs(SNPjunvecs[i,] *dictvecs[i,]`/(corrlen[i,1]*corrlen[i,2]));
			* calculate correlations with first 5 PCs;
			  do j = 1 to 5;
			    corrlen[i,j+4]= abs((dictvecs[i,] *DGRPPC[j,]`)/corrlen[i,1]);
			    corrlen[i,j+9]= abs((snpvecs[i,] *DGRPPC[j,]`)/corrlen[i,2]);
			  end;
			  * calculate correlations;
		end;
		*print corrlen;
		create ddcorr from corrlen [colname= {dictlength snplength vcorr juncorr rdictPC1 rdictPC2 rdictPC3 rdictPC4 rdictPC5 rdgrpPC1 rdgrpPC2 rdgrpPC3 rdgrpPC4 rdgrpPC5}];
		append from corrlen;
		
		print 'Done with Correlations of dictionary and snps. Starting correlations of random snps with dictionary';
		* Get unique dictionary vectors ;

		* Do random correlations with each dictionary vector that has a match, taking the number of SNPs into account.;
		use dictsnpcount;
			  read all var{
				  %do i=1 %to 58;
				     madjPrin&i
				  %end;
				 } into dictvecs;
			  read all var{snpcount} into snpcount;	
		  close dictsnpcount;
		  use randdirs;
			  read all var{
				  %do i=1 %to 58;
				     Prin&i
				  %end;
				 } into randvecs;
			close randdirs;
			
			*Convert randvecs to December basis. ;
		print 'number of missing ' (sum(nmiss(randvecs))) (sum(nmiss(juneigvec[1:58,])));
		 snpxy=randvecs*juneigvec[1:58,];		
		 print (nrow(snpxy)) (ncol(snpxy));
		 randdec = snpxy*deceigvec[1:58,]`;
			*** Lots of random correlations with each dictionary vector.;
			*** randvecs are random vectors from the actual analysis.;
			print 'number of random' (nrow(randvecs));
			qcorrd=j(nrow(dictvecs),10,0);
		  do i = 1 to nrow(dictvecs);
		    * Do a separate calculation for each dictionary vector, using clusters of count long;
		    * print 'Snpcount' (snpcount[i]);
		      numrand=snpcount[i]*&bn;
			  corrd = j(&bn,2,.);
			  corrsn = j(snpcount[i],1);
			  chosen=j(numrand,1,0);
			  call randgen(chosen,'UNIFORM');
			  chosen=round(chosen*nrow(randdec)+0.5);
			  chvec=randdec[chosen,];
			  if sum(nmiss(chosen))>0 | sum(nmiss(chvec))>0 | sum(nmiss(dictvecs[i,]))>0 then do;
			    print 'Missing values';
	
			  end;
			  ncorr=0;
			  * calculate correlations;
			  * Calculate as many correlations as there are Snps or Ldclusters in the gene.;
			  do r = 1 to &bn;
			    do s=1 to snpcount[i];
				  ncorr=ncorr+1;
					  if nmiss(chvec[ncorr,])>0 | nmiss(dictvecs[i,])>0 then do;
			  print 'Chosen' i s (nrow(randdec)) (nrow(chosen)) (min(chosen)) (max(chosen)) (sum(nmiss(chosen)));
						print 'Missing values in s loop ' r s ncorr;
						print(chvec[ncorr-1:ncorr+1,]) (dictvecs[i,]);
						corrsn[s,1]=.;
					  end;
					  else do;
				  corrsn[s,1]=abs(chvec[ncorr,] *dictvecs[i,]`/(sqrt(chvec[ncorr,]*chvec[ncorr,]`)*sqrt(dictvecs[i,]*dictvecs[i,]`)));
					end;
				end;
				corrd[r,1]=max(corrsn); * Save the largest correlation out of snpcount correlations.;
				corrd[r,2]=corrsn[1];  * save a random correlation (the first is as good as any).;
				* print corrsn (nrow(corrsn)) (ncol(corrsn)) (corrd[r,1]);
			  end; * r;
		  	 call sort(corrd,1); * sort by the largest correlation.;
			 qcorrd[i,1]=corrd[round(&bn/2),1];  *median;
			 *qcorrd[i,2]=corrd[round(&bn*0.75),1];  * 75;
			 qcorrd[i,2]=corrd[round(&bn*0.90),1];  * 90;
			 qcorrd[i,3]=corrd[round(&bn*0.95),1];  * 95;
			 qcorrd[i,4]=corrd[round(&bn*0.99),1];  * 99;
			 qcorrd[i,5]=corrd[&bn,1];  *max;
			 call sort(corrd,2);  * sort by the random correlation.;
			 qcorrd[i,6]=corrd[round(&bn/2),2];  *median;
			 *qcorrd[i,8]=corrd[round(&bn*0.75),2];  * 75;
			 qcorrd[i,7]=corrd[round(&bn*0.9),2];  * 9;
			 qcorrd[i,8]=corrd[round(&bn*0.95),2];  * 95;
			 qcorrd[i,9]=corrd[round(&bn*0.99),2];  * 99;
			 qcorrd[i,10]=corrd[&bn,2];  *max;

				end; *i;
				* In qcorrd, first set of 5 cq named quantiles is for the correlations adjusted for number of SNPs or cluster. 
				  Second set median and q, for just one correlation.;
			 create qcorrd from qcorrd [colname= {cmedian cq90 cq95 cq99 cq1000 median1 q901 q951 q991 q10001}];;
		 	   append from qcorrd; 
		**** Test overall distribution of correlations with dictionary vectors;


        ***** Now get correlations with random vectors sampled from the line mean covariance matrix.;
		  rqcorrd=j(nrow(dictvecs),5);
	      mu = j(58,1,0);
			use dictsnpcount;
			  read all var{
				  %do i=1 %to 58;
				     madjPrin&i
				  %end;
				 } into dictvecs;
			  read all var{snpcount} into snpcount;	
		  close dictsnpcount;
		  do i = 1 to nrow(dictvecs);
			  corrd = j(&bn,1);
			  corrsn = j(snpcount[i],1);
			  do r = 1 to &bn;
			    flyeffects=j(snpcount[i],59);
			    do s=1 to snpcount[i];
				  call vnormal(flyeffects,mu,linecov,snpcount[i]);
				  corrsn[s,1]=abs(flyeffects[s,] *dictvecs[i,]`/(sqrt(flyeffects[s,]*flyeffects[s,]`)*sqrt(dictvecs[i,]*dictvecs[i,]`)));
				end;
				corrd[r,1]=max(corrsn);
				* print corrsn (corrd[r,1]);
			  end; * r;
		  	 call sort(corrd,1);
			 rqcorrd[i,1]=corrd[round(&bn/2),1];  *median;
			 *rqcorrd[i,2]=corrd[round(&bn*0.75),1];  * 75;
			 rqcorrd[i,2]=corrd[round(&bn*0.90),1];  * 90;
			 rqcorrd[i,3]=corrd[round(&bn*0.95),1];  * 95;
			 rqcorrd[i,4]=corrd[round(&bn*0.99),1];  * 99;
			 rqcorrd[i,5]=corrd[&bn,1];  *max;
				end; *i;
			* rqcorrd has quantiles for vectors sampled from the covariance matrix.;
			 create rqcorrd from rqcorrd [colname= {rmedian r90 r95 r99 r1000}];;
		 	   append from rqcorrd; 
		quit;
	data quantilesdict;
	 merge dictsnpcount (keep=genec s2 snpcount) qcorrd rqcorrd;
	 run;
	data tempperm.glmveccorr&useclust.&cull.;
	 merge dictsnpcount ddcorr;
	 clust=symget('useclust');
	run;
	data vcq;
	length genec $8. ldcluster snpcount  vcorr 8. signif signif1 rsignif $3.cq95 q951 r95 rdgrpPC1 rdgrpPC2 rdgrpPC3 rdgrpPC4 rdgrpPC5 cmedian median1 rmedian 
          cq90 q901 r90 cq99 q991 r99 cq1000 q10001 r1000 glmeffsz dictlength snplength SNP  rdictPC1 rdictPC2 rdictPC3 rdictPC4 rdictPC5 8.;
	format vcorr 8.4 rdgrpPC1 rdgrpPC2 rdgrpPC3 rdgrpPC4 rdgrpPC5  rdictPC1 rdictPC2 rdictPC3 rdictPC4 rdictPC5 6.2 cq95 q951 r95 cmedian  median1 rmedian cq90 q901 r90 cq99 q991 r99 cq1000 q10001 r1000 7.3 juncorr 8.4 ;
	  merge tempperm.glmveccorr&useclust.&cull. quantilesdict;
	   by genec s2;
	   * adjusting for number of SNPs or clusters in the gene.;
	   select;
	     when (vcorr>cq99) signif='**';
	     when (vcorr>cq95) signif='*';
	     when (vcorr>cq90) signif='+';
	     when (vcorr>cmedian) signif='>';
		 otherwise signif='';
	   end;
	   * Each SNP or cluster treated as independent.;
	   select;
	     when (vcorr>q991) signif1='**';
	     when (vcorr>q951) signif1='*';
	     when (vcorr>q901) signif1='+';
	     when (vcorr>median1) signif1='>';
		 otherwise signif1='';
	   end;
	   * adjusting for number of SNPs or clusters in the gene. Drawing random vectors from the G matrix.;
	   select;
	     when (vcorr>r99) rsignif='**';
	     when (vcorr>r95) rsignif='*';
	     when (vcorr>r90) rsignif='+';
	     when (vcorr>rmedian) rsignif='>';
		 otherwise rsignif='';
	   end;
	   drop clust percent glmprinjun1-glmprinjun58 glmprindec1-glmprindec58 madjprin1-madjprin58 ;
	run;
%if %sysfunc(exist(tempperm.&outfile)) %then %do;
 proc datasets;
  append base= tempperm.&outfile data=vcq;
  run;
 %end;
 %else %do;
  data tempperm.&outfile.(label="Sig. against random SNP vectors (cq and q) or random draw from G (Rq): cq quantiles takes account of # of comparisons.") ;
   set vcq;
 run;
%end;

	proc sort;
	 by genec;
	 run;
%mend;
* clust uses the cluster identity and average vector.  Anything else uses the SNPs individually. ;

* These three run the post-cull analyses.;
%simpmatch(alldat.avedicteffprecull,1000,noclust,genesnpvect);
%simpmatch(alldat.avedicteffprecull,1000,clust,genesnpvect);
%simpmatch(alldat.avedicteffprecull,1000,ave,genesnpvect);

%simpmatch(alldat.avedicteff,1000,noclust);

* Basis for Table 2 in paper.;
PROC EXPORT DATA= alldata.Glmnetsimpcorrnoclustprecull 
            OUTFILE= "D:\Dropbox\DH\Flywing\DGRP\GLMnet\DGRPdistTable2.txt" 
            DBMS=TAB REPLACE;
     PUTNAMES=YES;
RUN;

PROC EXPORT DATA= alldata.Glmnetsimpcorrclustprecull 
            OUTFILE= "D:\Dropbox\DH\Flywing\DGRP\GLMnet\DGRPdistTable2clust.txt" 
            DBMS=TAB REPLACE;
     PUTNAMES=YES;
RUN;
PROC EXPORT DATA= alldata.Glmnetsimpcorraveprecull 
            OUTFILE= "D:\Dropbox\DH\Flywing\DGRP\GLMnet\DGRPdistTable2gene.txt" 
            DBMS=TAB REPLACE;
     PUTNAMES=YES;
RUN;
proc freq data=alldat.glmnetsimpcorrclustprecull;
  tables genec;
  run;
  proc sgplot data=alldat.glmnetsimpcorrclustprecull;
  proc sgplot data=alldat.glmnetsimpcorrnoclustprecull;
  proc sgplot data=alldat.glmnetsimpcorraveprecull;
   scatter x=snplength y=vcorr;
   run;

ods html close; /* close previous */
ods html; /* open new */

%macro distdictrand(numreps,useclust,vectl,cull); * This macro tests whether the distribution of random P-values is different from the observed. ;
title1 "prep work";
   title2 "Group 1 is real, Group 2 is random. Length > &vectl..";
%global dn;
* Read in the appropriate Dictionary Vectors .;
data vc;
 set tempperm.glmveccorr&useclust.&cull;
  where dictlength>&vectl;
run;
proc means dat=vc;
 var vcorr;
 run;

* Count the number of correlations to be calculated.;
%datasampsz(vc);
%let vecs=&dn;  * &vecs is the size of the set of correlations to calculate.;

* Get a set of random vectors.;
%let numlines=%eval(&numreps*&vecs);
proc surveyselect data=Eladio.hqmanova3 out=randdist n=&numlines;
run;

proc iml;
*** Read in the June and December bases.;
	  use alldata.interlableigjun;
	   read all var _ALL_ where(_TYPE_='SCORE') into juneigvec;
		read all var _ALL_ where(_TYPE_='MEAN') into junmeanvec;
	  close alldata.interlableigjun;
	    use alldata.interlableigdec;
	   read all var _ALL_ where(_TYPE_='SCORE') into deceigvec;
		read all var _ALL_ where(_TYPE_='MEAN') into decmeanvec;
	  close alldata.interlableigdec;
      use vc;
	  read all var{
		%do i = 1 %to 58;
		 madjPrin&i
		%end;
		} into dictvecs;
	  read all var{vcorr} into vcorr;
	  close vc;
  use randdist;
	read all var{
	%do i = 1 %to 58;
	 Prin&i
	%end;
	} into rdistvecs;
  close randdist;

  		*Convert rdistvecs to December basis. ;
		print 'number of missing ' (sum(nmiss(rdistvecs))) (sum(nmiss(juneigvec[1:58,])));
		 snpxy=rdistvecs*juneigvec[1:58,];		
		 print (nrow(snpxy)) (ncol(snpxy));
		 randdecvecs = snpxy*deceigvec[1:58,]`;

  * randomize order of random vectors;
  chosen=j(nrow(randdecvecs),1,0);
  call randgen(chosen,'UNIFORM');
  randdecvecs=randdecvecs||chosen;
  call sort(randdecvecs,ncol(randdecvecs));
  results = j(2*&numlines,3,0);
  row=0; rrow=0;
  do s = 1 to &numreps;
    row=(s-1)*2*&vecs;
    do d = 1 to &vecs;
	   rrow=rrow+1;
	   row=row+1;
	   results[row,1]=s;
	   results[row,2]=1;
	   * Group 1 - Real correlation between SNP and dictionary effect.;
	   results[row,3]=vcorr[d];
	   results[row+&vecs,1]=s;
	   results[row+&vecs,2]=2;
	   * Group 2 - Correlation between random vector and a dictionary vector;
	   results[row+&vecs,3]=abs(randdecvecs[rrow,1:58] *dictvecs[d,]`/(sqrt(randdecvecs[rrow,1:58]*randdecvecs[rrow,1:58]`)*sqrt(dictvecs[d,]*dictvecs[d,]`)));
	end;
  end;
  create randist from results [colname= {set group corr}];
  append from results;
quit;

ods exclude all; * Turns off the HTML output;
ods listing close;
ods output WilcoxonTest=Wilcoxon ANOVA=ANOVA;
proc npar1way data=randist ANOVA Wilcoxon;
   class group;
   var corr;
   by set;
   run;
ods output close; 
ods exclude none;  * Turns off the HTML output;
ods listing;
proc sort data=randist;
 by set group;
run;
proc means median data=randist noprint;
  var corr;
  by set group;
  output out=medcorr median=mediancorr;
run;
proc transpose data=medcorr prefix=median out=compcorr;
 var mediancorr;
 id group;
 by set;
 run;

data diffcorr&useclust;
 set compcorr;
 diffc=median2-median1;
run;
title1 "Plot of random-real difference of median correlations between real and random &useclust sets.";
proc univariate plot;
  var diffc;
  run;
data wilco&useclust;
 set wilcoxon;
 where Name1='PR_WIL';
 if cvalue1="<.0001" then pval=0.0001;
 else pval=cValue1+0;
 run;
title1 "Plot of Wilcoxon P values for comparison &useclust sets.";
proc univariate;
  var pval;
  run;
title1 "Plot of dictionary and snp lengths by correlation &useclust sets.";
*proc plot data=tempperm.glmveccorr&useclust;
* plot dictlength*vcorr snplength*vcorr;
 run;
 proc univariate data=anova;
  var ProbF;
  run;

%mend;

%distdictrand(1000,noclust,0.0,pre);
%distdictrand(1000,ave,0.0,pre);
%distdictrand(1000,clust,0.0,pre);
proc corr data=tempperm.glmveccorrnoclustpre spearman;
 var dictlength snplength vcorr;
 run;
proc plot data=tempperm.glmveccorrclust(where=(dictlength>0.7 & snplength>0.5));
 plot dictlength*vcorr snplength*vcorr;
 run;
proc sort data=randist;
   by group;
   run;
 proc means data=randist;
   by group;
   var corr;
   run;
*** outputting vectors for graphing.;
data expdvd;
 set tempperm.glmveccorrnoclustpre;
 drop prinjun1-prinjun58;
 run;
 PROC EXPORT DATA= WORK.Expdvd 
            OUTFILE= "D:\Dropbox\DH\Flywing\DGRP\DGRPvsDictionary\GLMparrotgraphs.csv" 
            DBMS=CSV REPLACE;
     PUTNAMES=YES;
RUN;
**** End of comparing random and simple match correlations, pvalues.;

proc freq data=alldat.glmnetwithman;
 tables gene1;
run;


* This generates the random correlations with each of the dictionary vectors for comparison with trans correlations.;
%macro dictPCcorr(dictdata,bn,useclust);
 %global dn;
 options nomlogic nomprint nosymbolgen;
 data genesnps;
  set genesnpvect;
  where s2='Dictionary';
 run;

* options mlogic mprint symbolgen;
%if &useclust=clust %then %do;
	data forcorr;
	 set genesnps;
	 where clustrange<5000;
	run;
	proc sort data=forcorr;
	 by gene1 LDCluster;
	run;
	proc means noprint data=forcorr;
	 var GLMPrindec1-GLMPrindec58 GLMPrinjun1-GLMPrinjun58 glmeffsz;
	 by gene1 LDCluster;
	 weight MAC;
	 id snp;
	 output out=geneclustvect mean= GLMPrindec1-GLMPrindec58 GLMPrinjun1-GLMPrinjun58 glmeffsz;
	run;
	%datasampsz(geneclustvect);
    %let numsigsnps=&dn;
%end;
%else %do;  * non-clustered results.;
 %datasampsz(genesnps);
 %let numsigsnps=&dn;
%end;

%put Number of vectors = &numsigsnps;
proc iml;
*** Read in the June and December bases.;
	  use alldata.interlableigjun;
	    read all var _ALL_ where(_TYPE_='SCORE') into juneigvec;
		read all var _ALL_ where(_TYPE_='MEAN') into junmeanvec;
	  close alldata.interlableigjun;
	  use alldata.interlableigdec;
	    read all var _ALL_ where(_TYPE_='SCORE') into deceigvec;
		read all var _ALL_ where(_TYPE_='MEAN') into decmeanvec;
	  close alldata.interlableigdec;

*** Read in the dictionary vectors, labels.;
		use &dictdata;
		  read all var{
			  %do i=1 %to 58;
			     madjPrin&i
			  %end;
			} into dictvecs;
		read all var{genec} into alllab;
		close &dictdata;
		* Read in covariance matrix and PC vectors for the DGRP among-line covariance matrix.;
	    use lineigens;
			 read all var{ %do i=1 %to 58;
			     Prindec&i
			  %end; 
			}   where (_TYPE_='COV') into linecov; 
			read all var{ %do i=1 %to 58;
			     Prindec&i
			  %end; 
			}   where (_TYPE_='SCORE') into DGRPPC; 
			 close lineigens;
		junindec = juneigvec*deceigvec`;

		print (vecdiag(junindec));
		corrlen=j(nrow(dictvecs),16);
		decloadings = j(5,58,0);
		* This is creating each of the first 5 PC vectors in this December space.;
		do i = 1 to 5;
		  decloadings[i,i]=1;
		end;

		print 'Correlations of dictionary and various PCS.' (nrow(dictvecs));
		do i = 1 to nrow(dictvecs);
		  		corrlen[i,1]=sqrt(dictvecs[i,]*dictvecs[i,]`);
			* calculate correlations with first 5 PCs of the three different eigenvector sets: June, December and among line.;
			  do j = 1 to 5;
			    corrlen[i,j+1]= abs(dictvecs[i,] *DGRPPC[j,]`/(corrlen[i,1]));
			    corrlen[i,j+6]= abs(dictvecs[i,] *decloadings[j,]`/(corrlen[i,1]));
			    corrlen[i,j+11]= abs(dictvecs[i,] *junindec[j,]`/(corrlen[i,1]));
			  end;
			  * calculate correlations;
		end;
	
		* Now do correlations with random vectors.;
			*** randvecs are random vectors from the actual analysis.;
		  use randdirs;
			  read all var{
				  %do i=1 %to 58;
				     Prin&i
				  %end;
				 } into randvecs;
			close randdirs;
			* Convert randvecs to December basis. ;
		print 'number of missing ' (sum(nmiss(randvecs))) (sum(nmiss(juneigvec[1:58,])));
		*** snpxy is the 96 dimensional random vectors in the June space.;
		 *snpxy=randvecs*juneigvec[1:58,];		
		 *print (nrow(snpxy)) (ncol(snpxy));
		 *** randdec has the random vectors in the December space.;
		 *randdec = snpxy*deceigvec[1:58,]`;
		 * Multiplying first by the June eigenvectors, then the December does the same thing as multiplying directly by their product, junindec.;
		 randdec=randvecs*junindec[1:58,];
			*** Lots of random correlations with each dictionary vector.;
			print 'number of random' (nrow(randvecs));
			qcorrd=j(nrow(dictvecs),10,0);
		  do i = 1 to nrow(dictvecs);
		  *do i = 1 to 10;
		    * Do a separate calculation for each dictionary vector, using clusters of count long;
			* number of significant SNPs is part of this, because we are to correlate each Vector with all the DGRP vectors.;
		      numrand=&numsigsnps*&bn;
			  corrd = j(&bn,2,.); * For tracking the repetitions of a correlation set ( with each snp);
			  corrsn = j(&numsigsnps,1);  * For keeping the correlations with each random vector.;
			  chosen=j(numrand,1,0);
			  call randgen(chosen,'UNIFORM');
			  chosen=round(chosen*nrow(randdec)+0.5);
			  chvec=randdec[chosen,];
			  if sum(nmiss(chosen))>0 | sum(nmiss(chvec))>0 | sum(nmiss(dictvecs[i,]))>0 then do;
			    print 'Missing values';
			  end;
			  ncorr=0;
			  * calculate correlations;
			  do r = 1 to &bn;  * number of repetitions of whole;
			    do s=1 to &numsigsnps;  * number of snps to be comparing each dictionary vector to. ;
				  ncorr=ncorr+1;
					  if nmiss(chvec[ncorr,])>0 | nmiss(dictvecs[i,])>0 then do;
			 			 print 'Chosen' i s (nrow(randdec)) (nrow(chosen)) (min(chosen)) (max(chosen)) (sum(nmiss(chosen)));
			 			print 'Missing values in s loop ' r s ncorr;
						print(chvec[ncorr-1:ncorr+1,]) (dictvecs[i,]);
						corrsn[s,1]=.;
					  end;
					  else do;
					  * Calculates a vector correlation.;
				  corrsn[s,1]=abs(chvec[ncorr,] *dictvecs[i,]`/(sqrt(chvec[ncorr,]*chvec[ncorr,]`)*sqrt(dictvecs[i,]*dictvecs[i,]`)));
					end;
				end;
				corrd[r,1]=max(corrsn);  * Transfers over the maximum correlation from numsigsnps random correlations.;
				corrd[r,2]=corrsn[1]; * Just one random correlation from the set.;
				* print corrsn (corrd[r,1]);
			  end; * r;
		  	 call sort(corrd,1); * Sorts whole set by the maximum correlation for each numsigsnp correlation. ;
			 qcorrd[i,1]=corrd[round(&bn/2),1];  *median;
			 *qcorrd[i,2]=corrd[round(&bn*0.75),1];  * 75;
			 qcorrd[i,2]=corrd[round(&bn*0.90),1];  * 90;
			 qcorrd[i,3]=corrd[round(&bn*0.95),1];  * 95;
			 qcorrd[i,4]=corrd[round(&bn*0.99),1];  * 99;
			 qcorrd[i,5]=corrd[&bn,1];  *max;
			 call sort(corrd,2);  * Sorts whole set by the random correlations.;
			 qcorrd[i,6]=corrd[round(&bn/2),2];  *median;
			 *qcorrd[i,8]=corrd[round(&bn*0.75),2];  * 75;
			 qcorrd[i,7]=corrd[round(&bn*0.9),2];  * 9;
			 qcorrd[i,8]=corrd[round(&bn*0.95),2];  * 95;
			 qcorrd[i,9]=corrd[round(&bn*0.99),2];  * 99;
			 qcorrd[i,10]=corrd[&bn,2];  *max;

				end; *i;
			  * The variables without 1 at the end of their names are the quantiles of maximum correlations for each significant snp with each dictionary vector.;
			  * The variables with a 1 at the end of their names are the quantiles of random correlations with each dictionary vector.;
			 create qcorrd from qcorrd [colname= {cmedian cq90 cq95 cq99 cq1000 median1 q901 q951 q991 q10001}];;
		 	   append from qcorrd; 

		 *** Correlations with vectors drawn at random from the var-cov matrix.;
		  rqcorrd=j(nrow(dictvecs),10,0);
	      mu = j(58,1,0);
		  do i = 1 to nrow(dictvecs);
			  rcorrd = j(&bn,2,.); * For tracking the repetitions of a correlation set (with each snp);
			  rcorrsn = j(&numsigsnps,1);
			  do r = 1 to &bn;
			    flyeffects=j(&numsigsnps,59);
				call vnormal(flyeffects,mu,linecov,&numsigsnps);
			    do s=1 to &numsigsnps;  * number of snps to be comparing each dictionary vector to. ;
				  rcorrsn[s,1]=abs(flyeffects[s,] *dictvecs[i,]`/(sqrt(flyeffects[s,]*flyeffects[s,]`)*sqrt(dictvecs[i,]*dictvecs[i,]`)));
				end;
				rcorrd[r,1]=max(rcorrsn);
				rcorrd[r,2]=corrsn[1]; * Just one random correlation from the set.;
			  end; * r;
		  	 call sort(rcorrd,1); * Sorts whole set by the maximum correlation for each numsigsnp correlation. ;
			 rqcorrd[i,1]=rcorrd[round(&bn/2),1];  *median;
			 *rqcorrd[i,2]=corrd[round(&bn*0.75),1];  * 75;
			 rqcorrd[i,2]=rcorrd[round(&bn*0.90),1];  * 90;
			 rqcorrd[i,3]=rcorrd[round(&bn*0.95),1];  * 95;
			 rqcorrd[i,4]=rcorrd[round(&bn*0.99),1];  * 99;
			 rqcorrd[i,5]=rcorrd[&bn,1];  *max;
			print 'rcorrd sorted by max';
             print rcorrd;    
			 call sort(rcorrd,2);  * Sorts whole set by the random correlations.;
			 rqcorrd[i,6]=rcorrd[round(&bn/2),2];  *median;
			 *rqcorrd[i,8]=rcorrd[round(&bn*0.75),2];  * 75;
			 rqcorrd[i,7]=rcorrd[round(&bn*0.9),2];  * 9;
			 rqcorrd[i,8]=rcorrd[round(&bn*0.95),2];  * 95;
			 rqcorrd[i,9]=rcorrd[round(&bn*0.99),2];  * 99;
			 rqcorrd[i,10]=rcorrd[&bn,2];  *max;
				end; *i;
			 create rqcorrd from rqcorrd [colname= {rmedian r90 r95 r99 r1000 rmedian1 r901 r951 r991 r10001}];
		 	   append from rqcorrd; 
			print 'rcorrd sorted by random';
             print rcorrd;    
		**** Done with correlations with random vectors.;

create dictPCcorr from corrlen [colname= {dictlength  rPCDG1 rPCDG2 rPCDG3 rPCDG4 rPCDG5 rPCdec1 rPCdec2 rPCdec3 rPCdec4 rPCdec5
 rPCjun1 rPCjun2 rPCjun3 rPCjun4 rPCjun5}];
		append from corrlen;
	quit;
  data dictPCcorrs;
   format dictlength 8.4 RPCDG1 rpcdec1  rpcjun1 
RPCDG2 rpcdec2 rpcjun2 RPCDG3 rpcdec3 rpcjun3 RPCDG4 rpcdec4 rpcjun4 RPCDG5 rpcdec5 rpcjun5 8.2;
   merge &dictdata(keep=genec s2) dictPCcorr;
 run;
 proc sort data=dictPCcorrs;
  by genec s2;
  run;
data quantilesdict;
	 merge &dictdata(keep=genec s2) qcorrd rqcorrd;
	 run;
proc sort data=quantilesdict;
  by genec s2;
  run;
 data tempperm.dictavecutglm&useclust(label="Sig. against random SNP vectors (cq and q) or random draw from G (Rq): cq quantiles takes account of # of comparisons.");
	length genec s2 $10.  dictlength rpcDG1 rpcDG2 rpcdg3 rpcdg4 rpcdg5 cq95 q951 r95 r951 cmedian median1 rmedian rmedian1
   cq90 q901 r90 r901 cq99 q991 r99 r991 cq1000 q10001 r1000 r10001 8.;
	format rpcDG1 rpcDG2 rpcdg3 rpcdg4 rpcdg5 6.2 cq95 q951 r95 r951 cmedian median1 rmedian rmedian1
   cq90 q901 r90 r901 cq99 q991 r99 r991 cq1000 q10001 r1000 r10001 7.3 ;
	  merge dictPCcorrs quantilesdict;
	   by genec s2;
	run;
%mend;
%dictPCcorr(alldat.avedicteffpc,1000,noclust);
%dictPCcorr(alldat.avedicteffpc,1000,clust);


********************************************************************;
* Matching all GLMnet signif SNPs with all dictionary vectors.;
* This does just the shape vectors, not the logcs.; 
* This depends on precalculating the significant in dictPCcorr, stored in alldata.dictavecutglm;
%macro allvecbyallsnp(dictdata,useclust);

* Naming output.;
%if %index(&dictdata,pc)>1 %then %do;
   %let outfile=vecaveallglm&useclust.pc;
	proc sort data=&dictdata;
	 by genec;
	run; 
%end;

%else %do;
   %let outfile=vecaveallglm&useclust;
	proc sort data=&dictdata;
	 by genec;
	run; 
 %end;
* delete old output files.;
%if %sysfunc(exist(tempperm.&outfile)) %then %do;
proc datasets lib=tempperm;
 delete &outfile;
  run;
 %end;
 options nomlogic nomprint nosymbolgen;

%if &useclust=clust %then %do;
* Only clusters less than 5kb apart are included.;
	data forcorr;
	 set genesnpvect;
	 where clustrange<5000;
	run;
	proc sort data=forcorr;
	 by gene1 LDCluster;
	run;
	proc means noprint data=forcorr;
	 var GLMPrindec1-GLMPrindec58 GLMPrinjun1-GLMPrinjun58 glmeffsz;
	 by gene1 LDCluster;
	 weight MAC;
	 id snp;
	 output out=geneclustvect mean= GLMPrindec1-GLMPrindec58 GLMPrinjun1-GLMPrinjun58 glmeffsz;
	run;
	data alldat.glmgeneclustvect;
	 set geneclustvect;
	 run;
 %end;
 %else %do;
		data geneclustvect;
		 set genesnpvect;
		 where s2='Dictionary';
		run;
%end;
* options mlogic mprint symbolgen;
proc iml;
	use &dictdata;
		  read all var{
			  %do i=1 %to 58;
			     madjPrin&i
			  %end;
	 		} into dictvecs;
    read all var{genec s2} into dictlab;
	close &dictdata;
	use geneclustvect;
		  read all var{
		  %do i=1 %to 58;
		     GLMPrindec&i
		  %end;
		 } into SNPvecs;
		read all var{snp LDcluster} into snpnlab;
		read all var{gene1} into snplab;
	close geneclustvect;
	corrlen=j(nrow(snpvecs),3);
	print 'Correlations of dictionary and snps.';
	print 'Dictionary vectors'  (nrow(dictvecs)) ;
	print 'SNP  vectors'  (nrow(snpvecs)) ;
	totalcorrs=nrow(dictvecs)*nrow(snpvecs);
	print 'Total number of correlations is ' totalcorrs;
	corrvec=j(nrow(snpvecs),3,0);
	nc=0;
	do i = 1 to nrow(dictvecs);
	*do i = 1 to 10;
		if nmiss(snpvecs[i,])>0 | nmiss(dictvecs[i,])>0 then do;
			    print 'Missing values in i loop';
				print(chvec[ncorr,]) (dictvecs[i,]);
			  end;
		 dictlength=sqrt(dictvecs[i,]*dictvecs[i,]`);
		do j= 1 to nrow(snpvecs);
		*do j= 1 to 1;
				 labelcont=dictlab[i,] || snplab[j,];
				
				if (j=1) then do;
					dslab=labelcont;
					end;
				else do;
					dslab=dslab//labelcont;
				end;
				snplength=sqrt(snpvecs[j,]*snpvecs[j,]`);
			    corrvec[j,1]= abs(snpvecs[j,] *dictvecs[i,]`/(dictlength*snplength));
				corrvec[j,2]=dictlength;
				corrvec[j,3]=snplength;
			end; *j for snp vectors;
		*	print 'nrows ' (nrow(corrvec)) (nrow(dslab));
			corrsnp=snpnlab||corrvec;
		   if i=1 then do;
				corrsall=corrsnp;
				labsall=dslab;
			end;
			else do;
				corrsall=corrsall//corrsnp;
				labsall=labsall//dslab;
			end;
		end;  *i for dictionary vectors;
		create dscorr from corrsall[colname= {snp ldclust vcorr dictlength snplength }];
		append from corrsall;
		%if %index(&dictdata,pc)>1 %then create dslab from labsall[colname= {genec s2 gene1}];
		%else create dslab from labsall[colname= {genec s2 gene1 }]; 
 			;
		append from labsall;
	 	
		print 'Done with Correlations of dictionary and snps. Starting correlations of random snps with dictionary';



		quit;
		data allcorrs;
			format genec s2 $10. gene1 $15.;
			merge dslab dscorr;
		 run;
		proc sort;
		 by genec;
		 run;
		data tempperm.&outfile;
		length gene1  $15. snp ldclust 8. genec $8. s2 $4.  vcorr 8. signif signif1 rsignif $3. rpcdg1 rpcdg2 rpcdg3 rpcdg4 rpcdg5 cq95 q951 cmedian median1 cq90 q901 cq99 q991 cq1000 q10001 dictlength  SNP 8.;
	    format vcorr 8.4 rpcdg1 rpcdg2 rpcdg3 rpcdg4 rpcdg5 6.2 cq95 q951 cmedian  median1 cq90 q901 cq99 q991 cq1000 q10001 7.3 ;
	    merge allcorrs alldat.dictavecutglm&useclust;
			by genec s2;

		
	   select;
	     when (vcorr>cq99) signif='**';
	     when (vcorr>cq95) signif='*';
	     when (vcorr>cq90) signif='+';
		 otherwise signif='';
	   end;
		select;
	     when (vcorr>q991) signif1='**';
	     when (vcorr>q951) signif1='*';
		 otherwise signif='';
	   end;
	   select;
	     when (vcorr>r99) rsignif='**';
	     when (vcorr>r95) rsignif='*';
	     when (vcorr>r90) rsignif='+';
		 otherwise rsignif='';
	   end;
	   rename gene1=snpgene genec=Dictgene;
	run;
	proc sort;
	 by descending vcorr;
    run;

%mend;
* clust uses the cluster identity and average vector.  Anything else uses the SNPs individually. ;
%allvecbyallsnp(alldat.avedicteffpc,noclust);
%allvecbyallsnp(alldat.avedicteffpc,clust);

data sigglmall;
 set alldat.Vecaveallglmnoclustpc;
* where (signif^="" | signif1^='' | rsignif^="");
 * where (signif^="" | rsignif^="");
 where vcorr>0.5;
 run;
proc sort;
 by snpgene Dictgene;
 run;
PROC EXPORT DATA= WORK.Sigglmall 
            OUTFILE= "D:\Dropbox\DH\Flywing\DGRP\DGRPvsDictionary\GLMnetsnpbydict.csv" 
            DBMS=CSV REPLACE;
     PUTNAMES=YES;
RUN;
data sigglmall;
 set alldat.Vecaveallglmclustpc;
 *where (signif^="" | rsignif^="");
 * where (signif^="" | rsignif^="");
 where vcorr>0.5;
 run;
proc sort;
 by snpgene Dictgene;
 run;
%macro export(dset);
data exp;
 length gene1 genec expt $21.;
 set alldat.&dset;
 where vcorr>0.5 | signif^='';
 rename gene1=snpgene genec=dictgene;
run;
PROC EXPORT DATA= WORK.Exp 
            OUTFILE= "D:\Dropbox\IanShare\HighQualityData\&dset. summary.csv" 
            DBMS=CSV REPLACE;
     PUTNAMES=YES;
RUN;
%mend;

%export(vecaveallglmhqclust);
%export(vecaveallglmhqnoclust);


PROC EXPORT DATA= TEMPPERM.glmveccorrhqclust 
            OUTFILE= "D:\Dropbox\IanShare\HighQualityData\glmvecavecorrhqclust.csv" 
            DBMS=CSV REPLACE;
     PUTNAMES=YES;
RUN;

PROC EXPORT DATA= TEMPPERM.glmveccorrhqnoclust 
            OUTFILE= "D:\Dropbox\IanShare\HighQualityData\glmvecavecorrhqnoclust.csv" 
            DBMS=CSV REPLACE;
     PUTNAMES=YES;
RUN;

data expsimpcorrclustprecull;
 length genec $8. signif $3. ldcluster  6. vcorr 8. signif1 $3. effectshape dictlength 8. chrom $4. pos 8. numsnpcluster 4. dist1 8. class1 $5.;
 set tempperm.simpcorrclustprecull;
 	  select;
	   when (snp<2000000000) chrom='X';
	   when (snp<2200000000) chrom='2L';
	   when (snp<3000000000) chrom='2R';
	   when (snp<3200000000) chrom='3L';
       when (snp<4000000000) chrom='3R';
	   otherwise chrom='4';
	   end;  
 pos = snp-1e8*floor(snp/1e8);
 if signif='>' then signif=''; 
 if signif1='>' then signif1=''; 
 keep genec signif ldcluster vcorr signif1 effectshape dictlength chrom  pos numsnpcluster dist1 class1;
run;
PROC EXPORT DATA= WORK.Expsimpcorrclustprecull 
            OUTFILE= "D:\Dropbox\DH\Flywing\DGRP\DGRPvsDictionary\DictvsDGRP.csv" 
            DBMS=CSV REPLACE;
     PUTNAMES=YES;
RUN;

proc freq data=tempperm.simpcorrclustprecull;
 tables genec / out= genelist;
 run;
 proc sort;
  by count;
run;
data go;
  set alldat.glmnetwithman;
 rename cluster=ldcluster;
proc sort;
 by ldcluster;
 run;
data gomatch;
 length winggo1 $4.;
 merge tempperm.simpcorrclustprecull(in=a  where=(signif1='*' | signif1='+' | signif1='**') ) go (keep=ldcluster winggo1); *;
by ldcluster;
if A;
run;
proc sort nodupkey out=nodupm;
  by genec;
  run;
proc freq; tables winggo1;
run;
data gomatch;
 length winggo1 $4.;
 merge tempperm.simpcorrclustprecull(in=a ) go (keep=ldcluster winggo1); * where=(signif1='*' | signif1='+' | signif1='**');
by ldcluster;
if A;
run;
proc sort nodupkey out=nodupm;
  by genec;
  run;
proc freq; tables winggo1;
run;


* This is for the graphs for Figure 5.;
* dghqdict has the pre-culled results and those used in the paper.;
* tempperm has the results I did after Eladio left, with mysteriously lower correlations.;
data tosimpgraph;
 merge alldat.simpcorrclustprecull alldat.glmveccorrclust;
 drop prinjun1-prinjun58;
run;
data allgraph;
  set alldat.vecallchqclust;
  where gene1='ds' ;

  proc sort;
   by dictgene;

  run;
%macro rename;
data tograph;
 merge alldat.simpcorrclustprecull alldat.glmveccorrclust;
 drop prinjun1-prinjun58;
 rename 
 %do i = 1 %to 58;
   madjPrin&i=DictPC&i Prindec&i=ClustPCdec&i
 %end;
 ;
 drop s2 clust percent;
run;
%mend;
%rename;

PROC EXPORT DATA= WORK.tograph 
            OUTFILE= "D:\Dropbox\DH\Flywing\DGRP\DGRPvsDictionary\DictvsDGRPclustFigure.csv" 
            DBMS=CSV REPLACE;
     PUTNAMES=YES;
RUN;
